; *******************************************************************
; *                                                                 *
; *                          scribble_23.asm                        *
; *                                                                 *
; *   This app is based on Darrin Massena's PILA sample code.       *
; *   It requires Darrin's PILOT.INC and STARTUP.INC include files. *
; *   For info on how to write apps for the world's best palmtop,   *
; *   aim your browser at                                           *
; *   http://www.massena.com/darrin/pilot                           *
; *                                                                 *
; *   If you have any questions about this source code,             *
; *   please send them to howlett@iosphere.net                      *
; *                                                                 *
; *   This code is freeware and you are free to modify it as you    *
; *   wish, however you must register your own Creator ID before    *
; *   you distribute any modifications.                             *
; *                                                                 *
; *   This code has been severely optimized.  If you would like     *
; *   to see the unoptimized code, contact me.                      *
; *                                                                 *
; *   Andrew Howlett                                                *
; *   howlett@iosphere.net                                          *
; *   2 May 97                                                      *
; *                                                                 *
; *******************************************************************

        Appl    "Scribble", 'Scrb'                      ; define name and creator ID
                                                        ; creator ID is sometimes called AppType
                                                        ; creator type is #$53637262

        include "Pilot.inc"                             ; structs, constants
        include "Startup.inc"                           ; common startup code



kidbAIB         equ             $7FFE                   ; Application-defined resource ids
kidrPREF        equ             1                       ; don't know who made up these names
kidrTVER        equ             1
kidrTAIB        equ             1000
kidfMain        equ             1000
kidmMain        equ             1000
kidmClear       equ             1001
kidmNewPage     equ             1002
kidmRemovePage  equ             1003
kidmAbout       equ             1005
kidmCopy        equ             1006
kidcInputField  equ             1000
kidrAboutAlert  equ             1000
kidrAutoCopyOffAlert    equ     1001
kidrAutoCopyOnAlert     equ     1002
ScribbleAppType equ             $53637262               ; 'Scrb'
ScribbleDBType  equ             $44617461               ; 'Data'
LCDLength       equ             2640

;    This is the structure of record 0
;    I set the offset to 26 manually in the code
;    so I don't need the struct definition.
;struct  prefsType
;   textfield.26    
;    CurrentIndex.w
;endstruct

        data                                            ; global variables

global lastX.w                                          ; globals are offsets from a5
global lastY.w
global SkipNextEvent.w
global dbR.l
global InputFieldPtr.l
global LCDStart.l
global Rec0handle.l

CurrentIndex
        dc.w    0
dbNumRecords
        dc.w    1
ScribbleDBName
        dc.b    'sDB',0
NumString
        dc.b    '00',0

        code

; *******************************************************************
; *                                                                 *
; *   DWord PilotMain(Word cmd, void *cmdPBP, Word launchflags)     *
; *                                                                 *
; *   PilotMain is called by the startup code and implements        *
; *   a simple event handling loop.                                 *
; *                                                                 *
; *******************************************************************

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
local   err.w
local   evt.EventType
beginproc
        tst.w   cmd(a6)                                 ;sysAppLaunchCmdNormalLaunch is 0
        bne     PmReturn                                ;not a normal launch, bag out

        systrap FrmGotoForm(#kidfMain.w)

PmEventLoop                                             ; Doze until an event arrives

;        systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)

        move.w  #evtWaitForever, -(a7)
        pea.l   evt(a6)
        trap    #15
        dc.w    sysTrapEvtGetEvent

;        systrap SysHandleEvent(&evt(a6))                ; First handler is system
        trap    #15
        dc.w    sysTrapSysHandleEvent
        addq.l  #6, a7
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Second is menu handler
        systrap MenuHandleEvent(&0, &evt(a6), &err(a6))
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Third is application handler

        call    ApplicationHandleEvent(&evt(a6))
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Fourth is form handler.
                                                        ; Form handler is where our
                                                        ; custom code is located
        systrap FrmDispatchEvent(&evt(a6))
                                                        ; Return from PilotMain when an
PmEventDone                                             ; appStopEvent is received
        cmpi.w  #appStopEvent,evt+EventType.eType(a6)   ; time to stop?
        bne.s   PmEventLoop                             ; nope, loop until it is

PmReturn
        moveq   #0, d0
endproc


; *******************************************************************
; *                                                                 *
; *   Boolean ApplicationHandleEvent(EventType *pevt)               *
; *                                                                 *
; *   Handles these events:    frmLoadEvent                         *
; *                                                                 *
; *******************************************************************

proc ApplicationHandleEvent(pevt.l)

beginproc
        move.l  a3,-(a7)                ;save registers we're going to trash

        movea.l pevt(a6),a0                             ;a0 = pevt
        
        cmpi.w  #frmLoadEvent,EventType.eType(a0) 
        beq     FormLoadHandler
        cmpi.w  #appStopEvent,EventType.eType(a0) 
        beq     ApplicationStopHandler
        bra     ApplicationEventNotHandled

FormLoadHandler                                         ; Initialize the form and make it active

;2       systrap FrmInitForm(EventType.data+frmLoad.formID(a0).w)
        move.w  EventType.data+frmLoad.formID(a0), -(a7)
        trap    #15
        dc.w    sysTrapFrmInitForm
        move.l  a0, a3

;4       systrap FrmSetActiveForm(a0.l)
        move.l  a0, -(a7)
        trap    #15
        dc.w    sysTrapFrmSetActiveForm

;8       systrap FrmSetEventHandler(a3.l, &MainFormHandleEvent(pc))
        pea.l   MainFormHandleEvent(pc)
        move.l  a3, -(a7)
        trap    #15
        dc.w    sysTrapFrmSetEventHandler

;6       systrap FrmGetObjectIndex(a3.l, #kidcInputField.w)  ; get FieldInputPtr
        move.w  #kidcInputField, -(a7)
        move.l  a3, -(a7)
        trap    #15
        dc.w    sysTrapFrmGetObjectIndex
        
;6       systrap FrmGetObjectPtr(a3.l, d0.w)
        move.w  d0, -(a7)
        move.l  a3, -(a7)
        trap    #15
        dc.w    sysTrapFrmGetObjectPtr
        
        move.l  a0, InputFieldPtr(a5)
        move.l  #$fffffa00, a0            ; get the LSSA
        move.l  (a0), d0                  ; and add $12c
        add.l   #$12c, d0
        move.l  d0, LCDStart(a5)

OpenDatabase                                            ; try to open the database
;10     systrap DmOpenDatabaseByTypeCreator (#ScribbleDBType.l, #ScribbleAppType.l, #dmModeReadWrite.w)
        move.w  #dmModeReadWrite, -(a7)
        move.l  #ScribbleAppType, -(a7)
        move.l  #ScribbleDBType, -(a7)
        trap    #15
        dc.w    sysTrapDmOpenDatabaseByTypeCreator
        lea     36(a7), a7
        move.l  a0, dbR(a5)
        cmpa.w  #0, a0
        bne LoadZeroRecord

CreateDatabase                                          ; if the database doesn't exist, create it
;16     systrap DmCreateDatabase(#0.w, &ScribbleDBName(a5), #ScribbleAppType.l, #ScribbleDBType.l, #false.w)
        move.w  #false, -(a7)
        move.l  #ScribbleDBType, -(a7)
        move.l  #ScribbleAppType, -(a7)
        pea.l   ScribbleDBName(a5)
        clr.w   -(a7)
        trap    #15
        dc.w    sysTrapDmCreateDatabase
;10       systrap DmOpenDatabaseByTypeCreator (#ScribbleDBType.l, #ScribbleAppType.l, #dmModeReadWrite.w)
        move.w  #dmModeReadWrite, -(a7)
        move.l  #ScribbleAppType, -(a7)
        move.l  #ScribbleDBType, -(a7)
        trap    #15
        dc.w    sysTrapDmOpenDatabaseByTypeCreator
        move.l  a0, dbR(a5)
        
;12     systrap DmNewRecord (dbR(a5).l, &CurrentIndex(a5), #28.l)
        move.l  #28, -(a7)
        pea.l   CurrentIndex(a5)
        move.l  dbR(a5), -(a7)
        trap    #15
        dc.w    sysTrapDmNewRecord
        
        move.l  a0, Rec0handle(a5)

;8      systrap FldSetTextHandle(InputFieldPtr(a5).l, a0.l)
        move.l  a0, -(a7)
        move.l  InputFieldPtr(a5), -(a7)
        trap    #15
        dc.w    sysTrapFldSetTextHandle
        
;8      systrap FldDelete(InputFieldPtr(a5).l, #0.w, #23.w)
        move.l  #23, -(a7)
        move.l  InputFieldPtr(a5), -(a7)
        trap    #15
        dc.w    sysTrapFldDelete
        
        move.w  #1, CurrentIndex(a5)

;12     systrap DmNewRecord (dbR(a5).l, &CurrentIndex(a5), #LCDLength.l)
        move.l  #LCDLength, -(a7)
        pea.l   CurrentIndex(a5)
        move.l  dbR(a5), -(a7)
        trap    #15
        dc.w    sysTrapDmNewRecord

;8       systrap DmReleaseRecord (dbR(a5).l, CurrentIndex(a5).w, #true.w)
        move.w  #true, -(a7)
        move.w  CurrentIndex(a5), -(a7)
        move.l  dbR(a5), -(a7)
        trap    #15
        dc.w    sysTrapDmReleaseRecord
        lea     74(a7), a7
        
        call    ClearScreen()
        clr.w   d0
        call    SaveScreen()
        bra     ApplicationEventNotHandled

LoadZeroRecord
;4      systrap DmNumRecords(dbR(a5).l)
        move.l  dbR(a5), -(a7)
        trap    #15
        dc.w    sysTrapDmNumRecords

        subq.w  #1, d0
        move.w  d0, dbNumRecords(a5)

;6      systrap DmQueryRecord (dbR(a5).l, #0.w)
        clr.w   -(a7)
        move.l  dbR(a5), -(a7)
        trap    #15
        dc.w    sysTrapDmQueryRecord        
        
        move.l  a0, Rec0handle(a5)

;8      systrap FldSetTextHandle(InputFieldPtr(a5).l, a0.l)
        move.l  a0, -(a7)
        move.l  InputFieldPtr(a5), -(a7)
        trap    #15
        dc.w    sysTrapFldSetTextHandle

        move.l  Rec0handle(a5), -(a7)   ; I stack-optimized MemHandleLock
        trap    #15                     ; and MemHandleUnlock to save 28
        dc.w    sysTrapMemHandleLock    ; bytes
        move.w  26(a0), CurrentIndex(a5)
        trap    #15
        dc.w    sysTrapMemHandleUnlock
        lea     22(a7), a7

DrawForm
        call    LoadScreen()
        bra     ApplicationEventNotHandled

ApplicationStopHandler                                  ; Application Stop Handler
;8       systrap FldSetTextHandle(InputFieldPtr(a5).l, #0.l)
        clr.l   -(a7)
        move.l  InputFieldPtr(a5), -(a7)
        trap    #15
        dc.w    sysTrapFldSetTextHandle
        clr.w   d0
        call    SaveScreen()
        move.l  Rec0handle(a5), -(a7)
        trap    #15
        dc.w    sysTrapMemHandleLock
        systrap DmWrite (a0.l, #26.l, &CurrentIndex(a5), #2.l)
        trap    #15
        dc.w    sysTrapMemHandleUnlock
        lea     12(a7), a7
     
ApplicationEventNotHandled
        clr.b   d0

ApplicationEventReturn
        move.l  (a7)+,a3

endproc

; *******************************************************************
; *                                                                 *
; *   Boolean MainFormHandleEvent(EventType *pevt)                  *
; *                                                                 *
; *   Handles these events:    frmOpenEvent                         *
; *                            frmMenuEvent                         *
; *                            penDownEvent                         *
; *                                                                 *
; *******************************************************************

proc MainFormHandleEvent(pevt.l)

beginproc
        movem.l d3-d4,-(a7)                             ;save registers we're going to trash

        movea.l pevt(a6),a0                             ;  a0 = pevt
        move.w  EventType.eType(a0), d0                 ;  d0 = event type

        cmp.w   #keyDownEvent, d0                       ; Handle key down Events
        beq     KeyboardHandler
        cmp.w   #menuEvent,d0                           ; Handle Menu Events
        beq     MenuHandler

PenHandler
        move.w  EventType.screenX(a0), d3                ; move x into d1
        move.w  EventType.screenY(a0), d4                ; move y into d2
        cmp.w   #149, d4
        bgt     MFHNotHandled
        cmp.w   #15, d4
        blt     MFHNotHandled
        cmp.w   #penDownEvent, d0                       ; Handle pen Down Events
        beq     PenDownEventHandler
        cmp.w   #penUpEvent, d0                         ; Handle pen Up Events
        beq     PenEventHandler
        cmp.w   #penMoveEvent, d0                       ; Handle pen Move Events
        beq     PenEventHandler
MFHNotHandled
        clr.w   d0
        bra     MFHReturn

MenuHandler                                             ; Show "About" info box
        move.w  EventType.data+menu.itemID(a0), d0
        cmp.w   #kidmRemovePage, d0
        beq     MenuRemoveHandler
        cmp.w   #kidmCopy, d0
        beq     MenuCopyHandler
        cmp.w   #kidmAbout, d0
        bne     MFHHandled
        systrap FrmAlert(#kidrAboutAlert.w)
        bra     MFHHandled

MenuCopyHandler
;        systrap FldCopy(InputFieldPtr(a5).l)
;        systrap FldDrawField(InputFieldPtr(a5).l)
        move.l  InputFieldPtr(a5), -(a7)
        trap    #15
        dc.w    sysTrapFldCopy
        trap    #15
        dc.w    sysTrapFldDrawField
        addq.l  #4, a7
        bra     MFHHandled

MenuRemoveHandler                                        ; Clear menu chosen
        call    RemoveRecord ()
        bra     PageHandled

PageDownHandler
        move.w  CurrentIndex(a5), d4
        call    SaveScreen()
        move.w  CurrentIndex(a5), d3
        cmp.w   dbNumRecords(a5), d3
        beq     PageDownNewPageHandler

        addq.w  #$0001, CurrentIndex(a5)
        bra     PageHandled

PageDownNewPageHandler
        cmp.w   #1, d4
        bne     PageDownNewPageHandler1
        tst.w   d0
        beq     MFHHandled
PageDownNewPageHandler1
        addq.w  #$0001, CurrentIndex(a5)
        systrap DmNewRecord (dbR(a5).l, &CurrentIndex(a5), #LCDLength.l)
        cmpa    #0, a0
        bne     PageDownNewPageHandler2
        subq.w  #$0001, CurrentIndex(a5)
        bra     MFHHandled
        
PageDownNewPageHandler2
        systrap DmReleaseRecord (dbR(a5).l, CurrentIndex(a5).w, #true.w)
        addq.w  #1, dbNumRecords(a5)        
        call    ClearScreen()
        bra     MFHHandled

PageUpHandler
        cmp.w   #1, CurrentIndex(a5)
        beq     MFHHandled
        call    SaveScreen()
        tst     d0
        beq     PageHandled
        subq.w  #$0001, CurrentIndex(a5)

PageHandled
        call    LoadScreen()
        bra     MFHHandled

PenDownEventHandler
        move.w  EventType.screenX(a0), lastX(a5)         ; move x into lastX
        move.w  EventType.screenY(a0), lastY(a5)         ; move y into lastY
        not.w   SkipNextEvent(a5)
        bra     MFHNotHandled

PenEventHandler
        tst.w   SkipNextEvent(a5)                       ; skip first event
        beq     MFHNotHandled                           ; pen events must return d0=0

CheckPenUpEvent
        cmp.w   #penUpEvent, d0
        bne     DrawLineHandler
        clr.w   SkipNextEvent(a5)

DrawLineHandler
        systrap WinDrawLine(lastX(a5).w, lastY(a5).w, d3.w, d4.w)
        move.w  d3, lastX(a5)
        move.w  d4, lastY(a5)
        bra     MFHNotHandled

KeyboardHandler
        move.w  EventType.data+keyDown.chr(a0), d0
        cmp.w   #pageDownChr, d0             
        beq     PageDownHandler
        cmp.w   #pageUpChr, d0                 
        beq     PageUpHandler
        bra     MFHNotHandled

MFHHandled
        moveq.l #1, d0

MFHReturn
        movem.l (a7)+,d3-d4
endproc

; *******************************************************************
; *                                                                 *
; *    Void  ClearScreen (void)                                     *
; *                                                                 *
; *******************************************************************

proc ClearScreen()

beginproc

        systrap WinEraseWindow()                        ; Erase the window
        systrap FrmGetActiveForm()                      ; Get form pointer a0
        systrap FrmDrawForm(a0.l)                       ; Draw the form
;       systrap WinDrawLine (#0.w,#147.w,#160.w,#147.w)
;       move.w  #147, -(a7)
;       move.w  #160, -(a7)
        move.l  #$00a00093, -(a7)
        move.w  #147, -(a7)
        clr.w   -(a7)
        trap    #15
        dc.w    sysTrapWinDrawLine
        addq.l  #8,a7

; *********** ShowCurrentIndex
; *******************************************************************

        move.w  CurrentIndex(a5), d0
        move.l  d0,-(a7)
        pea.l   NumString(a5)
        trap    #15
        dc.w    sysTrapStrIToA
;        systrap StrLen(&NumString(a5))
        pea.l   NumString(a5)
        trap    #15
        dc.w    sysTrapStrLen
;        systrap WinDrawChars (&NumString(a5), d0.w, #150.w, #150.w)
        move.l  #$00960096, -(a7)
        move.w  d0, -(a7)
        pea.l   NumString(a5)
        trap    #15
        dc.w    sysTrapWinDrawChars
        lea     22(a7), a7

endproc

; *******************************************************************
; *                                                                 *
; *    Void   RemoveRecord (void)                                   *
; *                                                                 *
; *******************************************************************

proc RemoveRecord()

beginproc

        cmp.w   #1, dbNumRecords(a5)
        beq     RemoveRecordClearScreen
        subq.w  #1, dbNumRecords(a5)
        systrap DmRemoveRecord (dbR(a5).l, CurrentIndex(a5).w)
        subq.w  #1, CurrentIndex(a5)
        bne     RemoveRecordHandled
        move.w  #$01, CurrentIndex(a5)
        bra     RemoveRecordHandled

RemoveRecordClearScreen
        call    ClearScreen()
        clr.w   d0
        call    SaveScreen()
RemoveRecordHandled
endproc

; *******************************************************************
; *                                                                 *
; *    Void   SaveScreen (void)                                     *
; *                                                                 *
; *    entry  d0 = 0  -  don't test screen                          *
; *                1  -  test screen                                *
; *                                                                 *
; *    returns    0  -  blank record deleted                        *
; *               1  -  record saved                                *
; *******************************************************************

proc SaveScreen()

beginproc

; *************  TestScreen 
; *******************************************************************

        tst.w   d0
        beq     TestScreenNotZero

        move.l  LCDStart(a5), a0                          ; copy screen from record
        clr.w   d0
TestLoop
        tst.l   (a0,d0)
        bne     TestScreenNotZero
        addq.w  #4, d0
        cmp.w   #LCDLength, d0
        blt     TestLoop
        call    RemoveRecord()
        clr.w   d0
        bra     SaveScreenHandled

TestScreenNotZero

; *************  SaveScreen
; *******************************************************************

        systrap DmQueryRecord (dbR(a5).l, CurrentIndex(a5).w)
        move.l  a0, -(a7)
        trap    #15
        dc.w    sysTrapMemHandleLock
;        systrap DmWrite (a0.l, #$00000000.l, LCDStart(a5).l, #LCDLength.l)
        move.l  #LCDLength, -(a7)
        move.l  LCDStart(a5), -(a7)
        clr.l   -(a7)
        move.l  a0, -(a7)
        trap    #15
        dc.w    sysTrapDmWrite
        lea     16(a7), a7
        trap    #15
        dc.w    sysTrapMemHandleUnlock
        addq.l  #4, a7
        moveq.l #1, d0

SaveScreenHandled
endproc

; *******************************************************************
; *                                                                 *
; *    Void   LoadScreen (void)                                     *
; *                                                                 *
; *******************************************************************

proc LoadScreen()

beginproc
        move.l a3,-(a7)                                ;save registers we're going to trash

        call ClearScreen()
        systrap DmQueryRecord (dbR(a5).l, CurrentIndex(a5).w)

        move.l  a0, -(a7)
        trap    #15
        dc.w    sysTrapMemHandleLock

        move.l  LCDStart(a5), a3                          ; copy screen from record
        clr.l   d0        
MoveLoop
        move.l  (a0,d0), (a3,d0)
        addq.l  #4, d0
        cmp.w   #LCDLength, d0
        blt     MoveLoop

        trap    #15
        dc.w    sysTrapMemHandleUnlock
        addq.l  #4, a7
        
        move.l (a7)+,a3
endproc

; *******************************************************************
; *                                                                 *
; *   Resources                                                     *
; *                                                                 *
; *   WBMP - Application Icon Bitmap resource.  Automatically       *
; *          converted from Windows format to Pilot format and      *
; *          written as a 'tAIB' rather than 'Tbmp' because kidbAIB *
; *          is a special value ($7ffe).                            *
; *   pref - Preference resource.  Defines app launch flags,        *
; *          stack and heap size.                                   *
; *   tFRM - Form resource.  Defined in scribble.rcp                *
; *   tver - Version resource                                       *                      *
; *   MBAR - Menu resource.  Defined in scribble.rcp                *
; *   Talt - Alert resource.  Defined in scribble.rcp               *
; *                                                                 *
; *   Filenames for scribble.rcp generated binaries are the         *
; *   resource type, followed by the ID in hexadecimal.             *
; *   E.g.  MBAR ID 1000 ==> mbar03e8.bin                           *
; *                                                                 *
; *******************************************************************

        res 'WBMP', kidbAIB, "Scribble.bmp"

        res 'pref', kidrPREF
        dc.w    sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
        dc.l    $1000                   ; stack size
        dc.l    $1000                   ; heap size

        res 'MBAR', kidmMain, "mbar03e8.bin"

        res 'tFRM', kidfMain, "tfrm03e8.bin"

        res 'tver', kidrTVER            
        dc.b    '2.3', 0

        res 'Talt', kidrAboutAlert, "talt03e8.bin"

; ********************   debug code
;
;  this line can be used to insert a breakpoint
;
;       systrap ErrDisplayFileLineMsg (&ErrorString(a5), #163.w, &ErrorString(a5))
;
